import meshio
import statistics
import math

panel_area = 0.6 * 0.4
distance = 3.0
air_density = 1.18 # @25C and 1 bar

mesh = meshio.read('case_t0001.vtu')

#print(mesh.point_data['u EigenMode1'])


def calc_dba(spl, f):
    a = 12194 ** 2
    b = 737.9 ** 2
    c = 107.7 ** 2
    d = 20.6 **2

    f2 = f * f
    f4 = f2 * f2

    N = a * f4

    D = (f2 + d) * math.sqrt((f2 + c)*(f2 + b)) * (f2 + a)

    return 20 * math.log10(spl * N/D) + 2


with open('eigenvalues.dat') as f:
    strFreq = f.readline().strip().split('   ')

eigenFreqs = []
for s in strFreq:
    eigenFreqs.append(float(s))

print(eigenFreqs)

def mean(plst):
    tot = 0
    for pval in plst:
        tot += pval[2]

    return math.fabs(tot/len(plst))



for modeIndex in range(25):
    modeName = 'u EigenMode' + str(modeIndex+1)
    modeData = mesh.point_data[modeName]
    ef = eigenFreqs[modeIndex]
    spl = mean(modeData) * eigenFreqs[modeIndex]**2 * 2 * math.pi * panel_area * air_density / distance

    dba = calc_dba(spl, ef)

    print(f'{ef:.0f}  {dba:.0f}')
